﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace WebAPIJquery.Controllers
{
    public class IndexController : ApiController
    {
        #region GET 방식
        [HttpGet]
        public IEnumerable<UserData> GetList_Get()
        {
            return CList.Instance.GetList().ToList();
        }

        [HttpGet]
        public UserData GetItem_Get(int id)
        {
            return CList.Instance.GetItem(id);
        }

        [HttpGet]
        public void Add_Get(int id, string sName)
        {
            CList.Instance.Add(id, sName, DateTime.Now);
        }

        [HttpGet]
        public void Remove_Get(int id)
        {
            CList.Instance.Remove(id);
        }
        #endregion

        #region POST 방식
        [HttpPost]
        public IEnumerable<UserData> GetList_Post()
        {
            return CList.Instance.GetList().ToList();
        }

        [HttpPost]
        public UserData GetItem_Post([FromBody]int nIndex)
        {
            return CList.Instance.GetItem(nIndex);
        }

        [HttpPost]
        public void Add_Post([FromBody]object objData)
        {
            dynamic m = JsonConvert.DeserializeObject<dynamic>(objData.ToString());
            CList.Instance.Add( (int)m.nId, (string)m.sName, DateTime.Now);
        }

        [HttpPost]
        public void Add_Post2([FromBody]UserData oData)
        {
            oData.WriteDate = DateTime.Now;
            CList.Instance.Add(oData);
        }

        [HttpPost]
        public void Remove_Post([FromBody]int nIndex)
        {
            CList.Instance.Remove(nIndex);
        }
        #endregion
    }
}
